package FiguryWersja02;

// Zmodyfikowana implementacja programu obliczającego obiektowo pola figur. 
// Dla zwartości kodu tylko kwadrat i koło. Krok w stronę SOLID, funkcja main
// została oparta na abstracji (klasa Figura), jest rozszerzalna na nowe figury
// i nie wymaga modyfikacji. Zależności od klas konkretnych zostały przeniesione
// do odrębnych metod, produkcją obiektów konkretnych klas zajęła się metoda 
// wytwórcza. Przy ustalaniu parametrów poszczególnych figur zastosowano
// operator instanceof oraz konwersje "w dół" (downcasting) z wykorzystaniem 
// rzutowania.
import java.util.Scanner;

abstract class Figura
{
    abstract public String podajNazwe();
    abstract public double pole();
}

class Kwadrat extends Figura
{
    public Kwadrat(double bok) { this.bok = bok; }
    public Kwadrat() { this(0); }
    @Override
    public double pole() { return bok * bok; }
    public void ustawBok(double bok) { this.bok = bok; }
    public double pobierzBok() { return bok; }
    @Override
    public String podajNazwe() { return "kwadrat"; }    
    private double bok;
}

class Kolo extends Figura
{
    public Kolo(double promien) { this.promien = promien; }
    public Kolo() { this(0); }
    @Override
    public double pole() { return Math.PI * promien * promien; }
    public void ustawPromien(double promien) { this.promien = promien; }
    public double pobierzPromien() { return promien; }
    @Override
    public String podajNazwe() { return "koło"; }  
    private double promien;
}

public class Figury02 
{
    static Scanner wejscie = new Scanner(System.in);
    public static void pokazMenu()
    {
        System.out.print("\n1. Kwadrat\n2. Koło\n0. Koniec\n>> ");
    }
    public static Figura utworzFigure(int kodFigury)
    {
        switch(kodFigury)
        {
            case 1  : return new Kwadrat();
            case 2  : return new Kolo();
            default : return null;
        }
    }
    public static void ustalParametryFigury(Figura figura)
    {
        if( figura instanceof Kwadrat )
        {
            double bok;
            System.out.print("Podaj długość boku: ");
            bok = wejscie.nextDouble();
            ((Kwadrat)figura).ustawBok(bok);
        }
        if( figura instanceof Kolo )
        {
            double promien;
            System.out.print("Podaj długość promienia: ");
            promien = wejscie.nextDouble();
            ((Kolo)figura).ustawPromien(promien);
        }    
    }
    
    public static void main(String[] args) 
    {
        int kodFigury;
        System.out.println("Obliczam pola figur, proszę wybrać figurę");
        
        Figura figura;
        do
        {
            pokazMenu();
            kodFigury = wejscie.nextInt();
            if((figura = utworzFigure(kodFigury)) != null)
            {
                ustalParametryFigury(figura);
                double pole = figura.pole();
                System.out.println( "Pole figury " + figura.podajNazwe() + " wynosi " + pole);
            }
        }
        while(kodFigury != 0);
    }
}